%% EXAMPLE1: Compute inverse square root of 3D-Laplacian

close all
clear all

%% setup A and v
N = 20;
T = gallery('tridiag',N); 
I = speye(N);
A = kron(kron(T,I),I) + kron(kron(I,T),I) + kron(kron(I,I),T);
v = randn(N^3,1);
tol = 1e-8;
maxit = 50;

%% run the method
tic
[f,xi,err] = invsqrtmv(A,v,tol,maxit);
toc

%% run it again to check the error (should be around tol)
g = invsqrtmv(A,f,tol,maxit);
norm(A\v - g)

%% plot results
semilogy(err,'k+-');
xlabel('iteration number');
ylabel('estimated absolute error');
grid on

